--Best = 49920

local M = {}

local scoreLand = 0
local scoreFinal = 0
local scoreRest = 0
local scenarioTime = 0
local distance = 0
local multiplier = 1
local powers = {false, false, false, false, false, false}
local reset = true
local scenarioTimeOut = 0
local file = require('scenario/fileHandler')
local powerupHandler = require('scenario/powerup')
local crystalHandling = require('scenario/crystalHandler')

local function onRaceStart()
	if not start then start = true end
end

local function success(score)
	local medal, nextMedal
	if score < 300 then 
		medal = 'None'
		nextMedal = 'Bronze(300)'
	elseif score >= 300 and score < 1000 then 
		medal = 'Bronze'
		nextMedal = 'Silver(1000)'
	elseif score >= 1000 and score < 2000 then 
		medal = 'Silver'
		nextMedal = 'Gold(2000)'
	elseif score >= 2000 and score < 4000 then 
		medal = 'Gold'
		nextMedal = 'Platinum(4000)'
	elseif score >= 4000 and score < 8000 then 
		medal = 'Platinum'
		nextMedal = 'Diamond(8000)'
	elseif score >= 8000 then 
		medal = 'Diamond'
		nextMedal = 'n/a'
	else
		medal = 'Broken'
		nextMedal = 'Also Broken'
	end
	
	file.setValueToSave(20, file.getMedalAsNumber(medal), 1)
	
    local result = {msg = 'Well Done! Your Score: '..score..' | You Achieved: '..medal..' | Next Medal: '..nextMedal..''}
	scenario_scenarios.finish(result)
end

local function onBeamNGTrigger(data)
	if data.triggerName == 'x2' and not powers[1] then
		powerupHandler.triggerMultiplier('x2', 0)
		powers[1] = true
		multiplier = multiplier*2
	elseif data.triggerName == 'x4_1' and not powers[2] then
		powerupHandler.triggerMultiplier('x4', 1)
		powers[2] = true
		multiplier = multiplier*4
	elseif data.triggerName == 'x4_2' and not powers[3] then
		powerupHandler.triggerMultiplier('x4', 2)
		powers[3] = true
		multiplier = multiplier*4
	elseif data.triggerName == 'x4_3' and not powers[4] then
		powerupHandler.triggerMultiplier('x4', 3)
		powers[4] = true
		multiplier = multiplier*4
	elseif data.triggerName == 'x8_1' and not powers[5] then
		powerupHandler.triggerMultiplier('x8', 1)
		powers[5] = true
		multiplier = multiplier*8
	elseif data.triggerName == 'x8_2' and not powers[6] then
		powerupHandler.triggerMultiplier('x8', 2)
		powers[6] = true
		multiplier = multiplier*8
	elseif data.triggerName == 'crystal_pickup' and data.event == 'enter' then crystalHandling.pickupCrystal(8)
	end
end

local function onPreRender(dt)
	if reset then
		TorqueScript.eval([[
			x2_board.position = "-522.389099 -833.364197 183.051788";
			x4_1_board.position = "-505.757477 -778.04126 136.382629";
			x4_2_board.position = "-568.670593 -736.752075 114.548019";
			x4_3_board.position = "-591.531982 -671.581482 46.5387459";
			x8_1_board.position = "-624.657043 -741.511658 148.555923";
			x8_2_board.position = "-612.603882 -794.38092 200.105988";
		]])
		reset = false
	end

	if crystalHandling.spawnCrystal(8) then crystalHandling.updateCrystal() end --Only render rotations of the crystal if it is necessary
end

local function finish()
	if scoreLand == 0 then
		local playerObject = scenetree.findObject('player')
		distance = math.floor(math.sqrt(math.pow(playerObject:getPosition().x+564, 2) + math.pow(playerObject:getPosition().y+683.6, 2), math.pow(playerObject:getPosition().z+0.01, 2)))
		scoreLand = 100-distance 
	end
	
	scoreRest = 100-distance
	scoreFinal = (scoreLand+scoreRest)*multiplier
	success(scoreFinal)
end

local function onRaceTick(raceTickTime)
	local playerObject = scenetree.findObject('player')
	scenarioTimeOut = scenarioTimeOut+raceTickTime
	
	if scenarioTimeOut >= 35 then finish() end
	
	if scoreLand == 0 then
		if playerObject:getPosition().z <= 40 then
			scoreLand = 100-distance 
		end
	else
		local playerData = map.objects[map.objectNames['player']]
		scenarioTime = scenarioTime+raceTickTime
		if scenarioTime >= 8 or playerData.vel:length() <= 0.025 then
			finish()
		else
			distance = math.floor(math.sqrt(math.pow(playerObject:getPosition().x+564, 2) + math.pow(playerObject:getPosition().y+683.6, 2), math.pow(playerObject:getPosition().z+0.01, 2)))
		end
	end
end

local function onScenarioChange(scenario)
	if scenario.state == 'pre-running' then
		if not crystalHandling.spawnCrystal(8) then crystalHandling.removeCrystal() end
	end
end

M.onRaceStart = onRaceStart
M.onRaceTick = onRaceTick
M.onBeamNGTrigger = onBeamNGTrigger
M.onPreRender = onPreRender
M.onScenarioChange = onScenarioChange
return M