local M = {}
local fileHandling = require('scenario/fileHandler')
local crysRot = {["core"] = 0, ["ringInner"] = 0, ["ringOuter"] = 0}

local function removeCrystal()
	TorqueScript.eval([[
		crystal.position = "10000 0 0";
		crystal_pickup.position = "10000 0 0";
		crystal_ring_inner.position = "10000 0 0";
		crystal_ring_outer.position = "10000 0 0";
	]])
end

local function pickupCrystal(level)
	ui_message('Crystal Collected!', 10, 'A')
	fileHandling.setValueToSave(level, 1, 3)
	removeCrystal()
end

local function spawnCrystal(level)
	local crystal = fileHandling.getValueFromSave(level, 3)
	if crystal == 1 then return false
	else return true
	end
end

local function updateCrystal()
	crysRot["core"] = crysRot["core"]+0.125
	crysRot["ringInner"] = crysRot["ringInner"]+0.5
	crysRot["ringOuter"] = crysRot["ringOuter"]+1
	TorqueScript.eval([[
		crystal.rotation = "0 0 -1 ]]..crysRot["core"]..[[";
		crystal_ring_inner.rotation = "-1 ]]..crysRot["ringInner"]..[[ ]]..crysRot["ringInner"]..[[ ]]..crysRot["ringInner"]..[[";
		crystal_ring_outer.rotation = "-1 ]]..crysRot["ringOuter"]..[[ ]]..crysRot["ringOuter"]..[[ ]]..crysRot["ringOuter"]..[[";
	]])
end

M.pickupCrystal = pickupCrystal
M.removeCrystal = removeCrystal
M.spawnCrystal  = spawnCrystal
M.updateCrystal = updateCrystal
return M